/**
* csv̓ǂݍ
* @func ReadCSV
* @parm string fileName ǂݍ݂t@Cl[iƂpXj
**/
function ReadCSV(fileName){
    var fileObj = new File(fileName);
    var csv = new Array();
    if(fileObj.open("r")){

        while(!fileObj.eof){
            csv.push(fileObj.readln().split(','));
             //debug//alert(fileObj.readln());
        }
        return csv;
    }else{
        alert("can't open "+fileName);
        return 0;
    }
}


/**
 * X}[gIuWFNgJāAX}[gIuWFNg
 * 摜𒣂tB
 * QlFhttp://qiita.com/IDs011da/items/1388bdcf63e058bf8848
 * @func EditSmartobject
 * @param layer ҏWX}[gIuWFNgC[
 * @param func ̃X}[gC[ł肽
**/
function EditSmartobject(layer,filePath){

    // ꉞC[̎ނ𔻕
    // X}[gIuWFNgȊÕC[ȂAȂ
    if(LayerKind.SMARTOBJECT == layer.kind){
        //alert("This Layer is SmartObject");
        var idAction = stringIDToTypeID( "placedLayerEditContents" );
        var idDesc = new ActionDescriptor();

        activeDocument.activeLayer = layer;
        executeAction(idAction, idDesc, DialogModes.NO);

        //̃X}[gC[ꂢɂB
        layObj = activeDocument.artLayers.add();

        //쐬̈ȊOSC[폜
        i = 0;
        do{
            if(layObj != activeDocument.artLayers[i]){
                activeDocument.artLayers[i].remove();
            }
            i++;
        }while(i <= activeDocument.artLayers.length);

        //Rsy
        open(new File(filePath));
        activeDocument.selection.selectAll();
        activeDocument.activeLayer.copy();
        activeDocument.close(SaveOptions.DONOTSAVECHANGES);

        //\tāǍ\t̃LpXTCYɍ킹
        activeDocument.activeLayer = activeDocument.paste();

        //X}[gIuWFNgۑAB
        activeDocument.save();
        activeDocument.close(SaveOptions.DONOTSAVECHANGES);
    }else{
        alert("This layer is not SmartObject");
    }
}


/**
 * ݂̃hLgpsd`ŗ^ꂽpathŕۑ
 * @param doc ۑΏۂ̃hLg
 * @param filePath t@CpX
**/
function SavePsd(doc,filePath){

    //ʖۑ
    //QlFhttp://www.openspc2.org/book/PhotoshopCS6/easy/save/008/index.html

    var anothernameObj  = new File(filePath);
    var psdOpt = new PhotoshopSaveOptions();
    psdOpt.alphaChannels = true;
    psdOpt.annotations = true;
    psdOpt.embedColorProfile = false;
    psdOpt.layers = true;
    psdOpt.spotColors = false;
    doc.saveAs(anothernameObj, psdOpt, true, Extension.LOWERCASE);
}

/**
* eXgJ[hpsdpngf[^쐬B
* ǂݍ܂ev[gpsdƃJ[hf[^̂csv𓯂OɂāA
* ɓǂݍ܂ĂˁI
* @function csv2png4testcard
* @param string foldername tH_̂ꏊ̃pX
* @param string filename ev[gpsdƃJ[hf[^csv̖O
**/
function csv2png4testcard(foldername,filename){
    //ʂ̉摜tH_I
    folderObj = new Folder(foldername+"/"+filename);
    folderObj.create();

    //pngp
    folderObj = new Folder(foldername+"/"+filename+"/png");
    folderObj.create();
    //ʂ̉摜tH_I
    folderObj = new Folder(foldername+"/"+filename+"/psd");
    folderObj.create();


    //csv̓ǂݍ
    var textdata = ReadCSV(foldername+"/"+filename+".csv");

    if(0 == textdata)return 0;
    //ev[gpsd̓ǂݍ
    if(!open(new File(foldername+"/"+filename+".psd")))return 0;

    var csvHeader = textdata[0];
    var csvLayerKind = textdata[1];
    //debug//alert(csvHeader+" "+csvHeader[0]);
    //csv3sڈȍ~[vŌĂяo
    for(var i=2;i<textdata.length;i++){
        //csv2sڂ̃t@CwɂāAt@Cǂݍ
        for(var j=0;j<csvHeader.length;j++){
            try{
                if(0 == csvLayerKind[j]){
                    //csvLayerKind 0 is nonLayer
                }else if(1 == csvLayerKind[j]){
                    //csvLayerKind 1 is textLayer
                    activeDocument.artLayers[csvHeader[j]].textItem.contents = textdata[i][j];
                }else if(2 == csvLayerKind[j]){
                    var temp = activeDocument;
                    //csvLayerKind 2 is smartLayer
                    EditSmartobject(activeDocument.artLayers[csvHeader[j]],foldername+"/image/"+textdata[i][j]);
                    activeDocument = temp;
                }
            }catch(e){
                alert(e);
            }
        }
         //debug//alert(textdata[i]);

        //output png
        var fileObj = new File(foldername+"/"+filename+"/png/"+textdata[i][0]+".png");
        var pngOpt = new PNGSaveOptions();
        pngOpt.interlaced = false;
        activeDocument.saveAs(fileObj,pngOpt,true,Extension.LOWERCASE);
        SavePsd(activeDocument,foldername+"/"+filename+"/psd/"+textdata[i][0]+".psd");
    }

    //close psd
    activeDocument.close(SaveOptions.DONOTSAVECHANGES);
}

//pick up csv files
var filePath = File.openDialog("csvIĂB");
var fileName = String(filePath).split("/").pop();
var folderName = String(filePath).replace("/"+fileName,"");
//create cards each csv files
csv2png4testcard(folderName,fileName.split(".")[0]);

